package com.zjinja.mcmod.decor.misc;

import com.zjinja.mcmod.decor.ZJinJaDecoration;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.model.obj.WavefrontObject;

public class RenderResource {
    public WavefrontObject Model;
    public ResourceLocation Texture;

    public RenderResource(WavefrontObject model, ResourceLocation texture){
        Model = model;
        Texture = texture;
    }

    public RenderResource(String ModelPath, String TexturePath){
        LoadResource(ModelPath, TexturePath);
    }

    public RenderResource(){
        Model = null;
        Texture = null;
    }

    public void LoadResource(String ModelPath, String TexturePath){
        Model = new WavefrontObject(new ResourceLocation(ZJinJaDecoration.MODID, ModelPath));
        Texture = new ResourceLocation(ZJinJaDecoration.MODID, TexturePath);
    }

    public void LoadBlockResource(String ModelName, String TextureName){
        String modelloc = "models/blocks/" + ModelName + ".obj";
        String textureloc = "textures/blocks/" + TextureName + ".png";
        if(ZJinJaDecoration.DebugMode) {
            ZJinJaDecoration.logger.warn("[Model Location] " + modelloc);
            ZJinJaDecoration.logger.warn("[Texture Location] " + textureloc);
        }
        LoadResource(modelloc, textureloc);
    }

    public void LoadBlockResource(String BlockName){
        LoadBlockResource(BlockName, BlockName);
    }
}
